#include <iostream.h>
#include <stdlib.h>
#include "charQueue.h"
#include "main.h" 
// defines kMaxBufferSize to be a constant short integer of size 81

void main()
{
	charQueue* theQueue;
	try
	{
	  theQueue = new charQueue();
	  theQueue->add('f');
	  theQueue->add('o');
	  theQueue->add('o');
	}
	catch (...)
	{
	  cout << "Internal error: Could not put characters into the queue." << endl;
	  exit(0);
	}
	
	// now lets copy the contents of the queue into an array
	char buffer[kMaxBufferSize];
	short i=0; // an index into buffer
	try
	{
	  for (i=0; i < kMaxBufferSize; i++) // a C++ idiom for "do forever"
	  {
		// when queue is empty, remove throws a queueEmpty exception
		buffer[i] = theQueue->remove();
	  }
	  throw BufferFullException();
	}
	catch (charQueue::BufferFullException )
	{
	  cout << "Internal error: buffer full." << endl;
	  exit(0);
	}
	catch (charQueue::QueueEmpty )
	{
	  cout << "Buffer contains " << buffer << endl;
	}
	catch (...)
	{
	  cout << "Internal error while reading character queue." << endl;
	  exit(0);
	}
	delete theQueue;
}

