//
// ShowProgress
//
// Note: Be sure to add a DWORD member to this class called dwLastTickCount.
// Initialize that member to zero. Reset it to zero in NPP_DestroyStream().
void CWorker::ShowProgress (NPP instance, 
                            uint32 FileSize, 
                            int32 Offset, 
                            int32 length)
{
  DWORD dwCurrentTick = GetTickCount();

  if (0 != this->dwLastTickCount)
  {
float BytesPerSecond = (float) length / 
       ((float) (dwCurrentTick - this->dwLastTickCount) / 
       (float) (dwCurrentTick - this->dwLastTickCount) / (float) 1000.0);
    int SecondsRemaining = (int) ((FileSize - Offset) / BytesPerSecond);
    int MinutesRemaining = SecondsRemaining / 60;
    SecondsRemaining -= MinutesRemaining * 60;
    CString OutPut;
    int PercentComplete;

    // Sometimes FileSize is zero. Handle that case properly.
    if (0 != FileSize)
    {
      PercentComplete = (int)((float)(100.0*Offset) / (float)FileSize);

      OutPut.Format ("%d%% of %dK (at%8.0f Kbps, %2d:%02d remaining)",
        PercentComplete,
        FileSize / 1024,
        BytesPerSecond / 1024.0,
        MinutesRemaining,
        SecondsRemaining);
    }
    else
      OutPut.Format ("%8.0f kbps)",
        BytesPerSecond / 1024);
    NPN_Status (instance, OutPut.GetBuffer(OutPut.GetLength()));
  }

  this->dwLastTickCount = dwCurrentTick;
}

